﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Microsoft.Phone.Controls;
//////////////
using System.IO;
using System.Xml.Linq; // System XML handling 위하여 

namespace RSSReader
{
    // 데이터 바인딩
    public class Post
    {
        // Property 
        public string Title { get; set; } // 제목
        public string Author { get; set; } // 글쓴이
        public string Link { get; set; } // 본문 링크
        public string Category { get; set; } // 분류
        public string PubDate { get; set; } // 작성일

        // Constructor 
        // public Post(string title, string author, string link, string category, string pubDate)
        public Post(string title, string pubDate)
        {
            Title = title;
            // Author = author;
            //Link = link;
            // Category = category;
            PubDate = pubDate;
        }

        
    }

    public class Posts : List<Post>
    {
    }

    public partial class MainPage : PhoneApplicationPage
    {
        Random rnd = new Random();
        Posts posts = new Posts();

        // Constructor
        public MainPage()
        {
            InitializeComponent();

            // RSS 주소 
            String strQuery = "http://blogs.msdn.com/b/jinhoseo/rss.aspx?rand=" + rnd.Next();

            // HttpWebRequest 를 이용해서 비동기 방식으로 데이터 가져오기
            HttpWebRequest request = (HttpWebRequest)WebRequest.Create(new Uri(strQuery));
            request.BeginGetResponse(new AsyncCallback(ReadCallback), request);
        }

        // HTTP 동기화로 데이터 가져오기 Callback 함수 호출
        private void ReadCallback(IAsyncResult result)
        {
            HttpWebRequest request = (HttpWebRequest)result.AsyncState;
            HttpWebResponse response = (HttpWebResponse)request.EndGetResponse(result);

            // 스트림으로 부터 데이터를 불러오기
            Stream stream = response.GetResponseStream();
            StreamReader reader = new StreamReader(stream);

            string strData = reader.ReadToEnd();
            reader.Close();
            stream.Close();

            // 데이터를 분석해서 화면에 나타낸다.
            DisplayResult(strData);
        }

        private void DisplayResult(string result)
        {
            XDocument doc = XDocument.Parse(result);
            var items = from item in doc.Descendants("item")
                        select new
                        {
                            Title = item.Element("title").Value,
                            // Author = item.Element("author").Value,
                            //Link = item.Element("Link").Value,
                            //Category = item.Element("category").Value,
                            PubDate = item.Element("pubDate").Value,
                        };

            foreach (var item in items)
            {
                Post post = new Post(item.Title, item.PubDate);
                posts.Add(post);
            }

            Dispatcher.BeginInvoke(delegate()
            {
                listPosts.ItemsSource = posts;
            });
        }

        


    }



}